# ----------------------------------------------------------------------------------------------------------------------
# - Package Imports -
# ----------------------------------------------------------------------------------------------------------------------
# General Packages
from __future__ import annotations

# Custom Library

# Custom Packages
from AthenaColor.Objects.Color.ColorSystem import RGB

# ----------------------------------------------------------------------------------------------------------------------
# - Code -
# ----------------------------------------------------------------------------------------------------------------------
class HtmlColorTuples:
    Maroon                  = 128,0  ,0
    DarkRed                 = 139,0  ,0
    Brown                   = 165,42 ,42
    Firebrick               = 178,34 ,34
    Crimson                 = 220,20 ,60
    Red                     = 255,0  ,0
    Tomato                  = 255,99 ,71
    Coral                   = 255,127,80
    IndianRed               = 205,92 ,92
    LightCoral              = 240,128,128
    DarkSalmon              = 233,150,122
    Salmon                  = 250,128,114
    LightSalmon             = 255,160,122
    OrangeRed               = 255,69 ,0
    DarkOrange              = 255,140,0
    Orange                  = 255,165,0
    Gold                    = 255,215,0
    DarkGoldenRod           = 184,134,11
    GoldenRod               = 218,165,32
    PaleGoldenRod           = 238,232,170
    DarkKhaki               = 189,183,107
    Khaki                   = 240,230,140
    Olive                   = 128,128,0
    Yellow                  = 255,255,0
    YellowGreen             = 154,205,50
    DarkOliveGreen          = 85 ,107,47
    OliveDrab               = 107,142,35
    LawnGreen               = 124,252,0
    Chartreuse              = 127,255,0
    GreenYellow             = 173,255,47
    DarkGreen               = 0  ,100,0
    Green                   = 0  ,128,0
    ForestGreen             = 34 ,139,34
    Lime                    = 0  ,255,0
    LimeGreen               = 50 ,205,50
    LightGreen              = 144,238,144
    PaleGreen               = 152,251,152
    DarkSeaGreen            = 143,188,143
    MediumSpringGreen       = 0  ,250,154
    SpringGreen             = 0  ,255,127
    SeaGreen                = 46 ,139,87
    MediumAquaMarine        = 102,205,170
    MediumSeaGreen          = 60 ,179,113
    LightSeaGreen           = 32 ,178,170
    DarkSlateGray           = 47 ,79 ,79
    Teal                    = 0  ,128,128
    DarkCyan                = 0  ,139,139
    Aqua                    = 0  ,255,255
    Cyan                    = 0  ,255,255
    LightCyan               = 224,255,255
    DarkTurquoise           = 0  ,206,209
    Turquoise               = 64 ,224,208
    MediumTurquoise         = 72 ,209,204
    PaleTurquoise           = 175,238,238
    AquaMarine              = 127,255,212
    PowderBlue              = 176,224,230
    CadetBlue               = 95 ,158,160
    SteelBlue               = 70 ,130,180
    CornFlowerBlue          = 100,149,237
    DeepSkyBlue             = 0  ,191,255
    DodgerBlue              = 30 ,144,255
    LightBlue               = 173,216,230
    SkyBlue                 = 135,206,235
    LightSkyBlue            = 135,206,250
    MidnightBlue            = 25 ,25 ,112
    Navy                    = 0  ,0  ,128
    DarkBlue                = 0  ,0  ,139
    MediumBlue              = 0  ,0  ,205
    Blue                    = 0  ,0  ,255
    RoyalBlue               = 65 ,105,225
    BlueViolet              = 138,43 ,226
    Indigo                  = 75 ,0  ,130
    DarkSlateBlue           = 72 ,61 ,139
    SlateBlue               = 106,90 ,205
    MediumSlateBlue         = 123,104,238
    MediumPurple            = 147,112,219
    DarkMagenta             = 139,0  ,139
    DarkViolet              = 148,0  ,211
    DarkOrchid              = 153,50 ,204
    MediumOrchid            = 186,85 ,211
    Purple                  = 128,0  ,128
    Thistle                 = 216,191,216
    Plum                    = 221,160,221
    Violet                  = 238,130,238
    Magenta                 = 255,0  ,255
    Orchid                  = 218,112,214
    MediumVioletRed         = 199,21 ,133
    PaleVioletRed           = 219,112,147
    DeepPink                = 255,20 ,147
    HotPink                 = 255,105,180
    LightPink               = 255,182,193
    Pink                    = 255,192,203
    AntiqueWhite            = 250,235,215
    Beige                   = 245,245,220
    Bisque                  = 255,228,196
    BlanchedAlmond	        = 255,235,205
    Wheat                   = 245,222,179
    CornSilk                = 255,248,220
    LemonChiffon            = 255,250,205
    LightGoldenRodYellow    = 250,250,210
    LightYellow             = 255,255,224
    SaddleBrown             = 139,69 ,19
    Sienna                  = 160,82 ,45
    Chocolate               = 210,105,30
    Peru                    = 205,133,63
    SandyBrown              = 244,164,96
    BurlyWood               = 222,184,135
    Tan                     = 210,180,140
    RosyBrown               = 188,143,143
    Moccasin                = 255,228,181
    NavajoWhite             = 255,222,173
    PeachPuff               = 255,218,185
    MistyRose               = 255,228,225
    LavenderBlush           = 255,240,245
    Linen                   = 250,240,230
    OldLace                 = 253,245,230
    PapayaWhip              = 255,239,213
    WeaShell                = 255,245,238
    MintCream               = 245,255,250
    SlateGray               = 112,128,144
    LightSlateGray          = 119,136,153
    LightSteelBlue          = 176,196,222
    Lavender                = 230,230,250
    FloralWhite             = 255,250,240
    AliceBlue               = 240,248,255
    GhostWhite              = 248,248,255
    Honeydew                = 240,255,240
    Ivory                   = 255,255,240
    Azure                   = 240,255,255
    Snow                    = 255,250,250
    Black                   = 0  ,0  ,0
    DimGray                 = 105,105,105
    Gray	                = 128,128,128
    DarkGray	            = 169,169,169
    Silver	                = 192,192,192
    LightGray	            = 211,211,211
    Gainsboro               = 220,220,220
    WhiteSmoke              = 245,245,245
    White                   = 255,255,255

class HtmlColorObjects:
    Maroon                  = RGB(*HtmlColorTuples.Maroon               )
    DarkRed                 = RGB(*HtmlColorTuples.DarkRed              )
    Brown                   = RGB(*HtmlColorTuples.Brown                )
    Firebrick               = RGB(*HtmlColorTuples.Firebrick            )
    Crimson                 = RGB(*HtmlColorTuples.Crimson              )
    Red                     = RGB(*HtmlColorTuples.Red                  )
    Tomato                  = RGB(*HtmlColorTuples.Tomato               )
    Coral                   = RGB(*HtmlColorTuples.Coral                )
    IndianRed               = RGB(*HtmlColorTuples.IndianRed            )
    LightCoral              = RGB(*HtmlColorTuples.LightCoral           )
    DarkSalmon              = RGB(*HtmlColorTuples.DarkSalmon           )
    Salmon                  = RGB(*HtmlColorTuples.Salmon               )
    LightSalmon             = RGB(*HtmlColorTuples.LightSalmon          )
    OrangeRed               = RGB(*HtmlColorTuples.OrangeRed            )
    DarkOrange              = RGB(*HtmlColorTuples.DarkOrange           )
    Orange                  = RGB(*HtmlColorTuples.Orange               )
    Gold                    = RGB(*HtmlColorTuples.Gold                 )
    DarkGoldenRod           = RGB(*HtmlColorTuples.DarkGoldenRod        )
    GoldenRod               = RGB(*HtmlColorTuples.GoldenRod            )
    PaleGoldenRod           = RGB(*HtmlColorTuples.PaleGoldenRod        )
    DarkKhaki               = RGB(*HtmlColorTuples.DarkKhaki            )
    Khaki                   = RGB(*HtmlColorTuples.Khaki                )
    Olive                   = RGB(*HtmlColorTuples.Olive                )
    Yellow                  = RGB(*HtmlColorTuples.Yellow               )
    YellowGreen             = RGB(*HtmlColorTuples.YellowGreen          )
    DarkOliveGreen          = RGB(*HtmlColorTuples.DarkOliveGreen       )
    OliveDrab               = RGB(*HtmlColorTuples.OliveDrab            )
    LawnGreen               = RGB(*HtmlColorTuples.LawnGreen            )
    Chartreuse              = RGB(*HtmlColorTuples.Chartreuse           )
    GreenYellow             = RGB(*HtmlColorTuples.GreenYellow          )
    DarkGreen               = RGB(*HtmlColorTuples.DarkGreen            )
    Green                   = RGB(*HtmlColorTuples.Green                )
    ForestGreen             = RGB(*HtmlColorTuples.ForestGreen          )
    Lime                    = RGB(*HtmlColorTuples.Lime                 )
    LimeGreen               = RGB(*HtmlColorTuples.LimeGreen            )
    LightGreen              = RGB(*HtmlColorTuples.LightGreen           )
    PaleGreen               = RGB(*HtmlColorTuples.PaleGreen            )
    DarkSeaGreen            = RGB(*HtmlColorTuples.DarkSeaGreen         )
    MediumSpringGreen       = RGB(*HtmlColorTuples.MediumSpringGreen    )
    SpringGreen             = RGB(*HtmlColorTuples.SpringGreen          )
    SeaGreen                = RGB(*HtmlColorTuples.SeaGreen             )
    MediumAquaMarine        = RGB(*HtmlColorTuples.MediumAquaMarine     )
    MediumSeaGreen          = RGB(*HtmlColorTuples.MediumSeaGreen       )
    LightSeaGreen           = RGB(*HtmlColorTuples.LightSeaGreen        )
    DarkSlateGray           = RGB(*HtmlColorTuples.DarkSlateGray        )
    Teal                    = RGB(*HtmlColorTuples.Teal                 )
    DarkCyan                = RGB(*HtmlColorTuples.DarkCyan             )
    Aqua                    = RGB(*HtmlColorTuples.Aqua                 )
    Cyan                    = RGB(*HtmlColorTuples.Cyan                 )
    LightCyan               = RGB(*HtmlColorTuples.LightCyan            )
    DarkTurquoise           = RGB(*HtmlColorTuples.DarkTurquoise        )
    Turquoise               = RGB(*HtmlColorTuples.Turquoise            )
    MediumTurquoise         = RGB(*HtmlColorTuples.MediumTurquoise      )
    PaleTurquoise           = RGB(*HtmlColorTuples.PaleTurquoise        )
    AquaMarine              = RGB(*HtmlColorTuples.AquaMarine           )
    PowderBlue              = RGB(*HtmlColorTuples.PowderBlue           )
    CadetBlue               = RGB(*HtmlColorTuples.CadetBlue            )
    SteelBlue               = RGB(*HtmlColorTuples.SteelBlue            )
    CornFlowerBlue          = RGB(*HtmlColorTuples.CornFlowerBlue       )
    DeepSkyBlue             = RGB(*HtmlColorTuples.DeepSkyBlue          )
    DodgerBlue              = RGB(*HtmlColorTuples.DodgerBlue           )
    LightBlue               = RGB(*HtmlColorTuples.LightBlue            )
    SkyBlue                 = RGB(*HtmlColorTuples.SkyBlue              )
    LightSkyBlue            = RGB(*HtmlColorTuples.LightSkyBlue         )
    MidnightBlue            = RGB(*HtmlColorTuples.MidnightBlue         )
    Navy                    = RGB(*HtmlColorTuples.Navy                 )
    DarkBlue                = RGB(*HtmlColorTuples.DarkBlue             )
    MediumBlue              = RGB(*HtmlColorTuples.MediumBlue           )
    Blue                    = RGB(*HtmlColorTuples.Blue                 )
    RoyalBlue               = RGB(*HtmlColorTuples.RoyalBlue            )
    BlueViolet              = RGB(*HtmlColorTuples.BlueViolet           )
    Indigo                  = RGB(*HtmlColorTuples.Indigo               )
    DarkSlateBlue           = RGB(*HtmlColorTuples.DarkSlateBlue        )
    SlateBlue               = RGB(*HtmlColorTuples.SlateBlue            )
    MediumSlateBlue         = RGB(*HtmlColorTuples.MediumSlateBlue      )
    MediumPurple            = RGB(*HtmlColorTuples.MediumPurple         )
    DarkMagenta             = RGB(*HtmlColorTuples.DarkMagenta          )
    DarkViolet              = RGB(*HtmlColorTuples.DarkViolet           )
    DarkOrchid              = RGB(*HtmlColorTuples.DarkOrchid           )
    MediumOrchid            = RGB(*HtmlColorTuples.MediumOrchid         )
    Purple                  = RGB(*HtmlColorTuples.Purple               )
    Thistle                 = RGB(*HtmlColorTuples.Thistle              )
    Plum                    = RGB(*HtmlColorTuples.Plum                 )
    Violet                  = RGB(*HtmlColorTuples.Violet               )
    Magenta                 = RGB(*HtmlColorTuples.Magenta              )
    Orchid                  = RGB(*HtmlColorTuples.Orchid               )
    MediumVioletRed         = RGB(*HtmlColorTuples.MediumVioletRed      )
    PaleVioletRed           = RGB(*HtmlColorTuples.PaleVioletRed        )
    DeepPink                = RGB(*HtmlColorTuples.DeepPink             )
    HotPink                 = RGB(*HtmlColorTuples.HotPink              )
    LightPink               = RGB(*HtmlColorTuples.LightPink            )
    Pink                    = RGB(*HtmlColorTuples.Pink                 )
    AntiqueWhite            = RGB(*HtmlColorTuples.AntiqueWhite         )
    Beige                   = RGB(*HtmlColorTuples.Beige                )
    Bisque                  = RGB(*HtmlColorTuples.Bisque               )
    BlanchedAlmond	        = RGB(*HtmlColorTuples.BlanchedAlmond	    )
    Wheat                   = RGB(*HtmlColorTuples.Wheat                )
    CornSilk                = RGB(*HtmlColorTuples.CornSilk             )
    LemonChiffon            = RGB(*HtmlColorTuples.LemonChiffon         )
    LightGoldenRodYellow    = RGB(*HtmlColorTuples.LightGoldenRodYellow )
    LightYellow             = RGB(*HtmlColorTuples.LightYellow          )
    SaddleBrown             = RGB(*HtmlColorTuples.SaddleBrown          )
    Sienna                  = RGB(*HtmlColorTuples.Sienna               )
    Chocolate               = RGB(*HtmlColorTuples.Chocolate            )
    Peru                    = RGB(*HtmlColorTuples.Peru                 )
    SandyBrown              = RGB(*HtmlColorTuples.SandyBrown           )
    BurlyWood               = RGB(*HtmlColorTuples.BurlyWood            )
    Tan                     = RGB(*HtmlColorTuples.Tan                  )
    RosyBrown               = RGB(*HtmlColorTuples.RosyBrown            )
    Moccasin                = RGB(*HtmlColorTuples.Moccasin             )
    NavajoWhite             = RGB(*HtmlColorTuples.NavajoWhite          )
    PeachPuff               = RGB(*HtmlColorTuples.PeachPuff            )
    MistyRose               = RGB(*HtmlColorTuples.MistyRose            )
    LavenderBlush           = RGB(*HtmlColorTuples.LavenderBlush        )
    Linen                   = RGB(*HtmlColorTuples.Linen                )
    OldLace                 = RGB(*HtmlColorTuples.OldLace              )
    PapayaWhip              = RGB(*HtmlColorTuples.PapayaWhip           )
    WeaShell                = RGB(*HtmlColorTuples.WeaShell             )
    MintCream               = RGB(*HtmlColorTuples.MintCream            )
    SlateGray               = RGB(*HtmlColorTuples.SlateGray            )
    LightSlateGray          = RGB(*HtmlColorTuples.LightSlateGray       )
    LightSteelBlue          = RGB(*HtmlColorTuples.LightSteelBlue       )
    Lavender                = RGB(*HtmlColorTuples.Lavender             )
    FloralWhite             = RGB(*HtmlColorTuples.FloralWhite          )
    AliceBlue               = RGB(*HtmlColorTuples.AliceBlue            )
    GhostWhite              = RGB(*HtmlColorTuples.GhostWhite           )
    Honeydew                = RGB(*HtmlColorTuples.Honeydew             )
    Ivory                   = RGB(*HtmlColorTuples.Ivory                )
    Azure                   = RGB(*HtmlColorTuples.Azure                )
    Snow                    = RGB(*HtmlColorTuples.Snow                 )
    Black                   = RGB(*HtmlColorTuples.Black                )
    DimGray                 = RGB(*HtmlColorTuples.DimGray              )
    Gray	                = RGB(*HtmlColorTuples.Gray	                )
    DarkGray	            = RGB(*HtmlColorTuples.DarkGray	            )
    Silver	                = RGB(*HtmlColorTuples.Silver	            )
    LightGray	            = RGB(*HtmlColorTuples.LightGray	        )
    Gainsboro               = RGB(*HtmlColorTuples.Gainsboro            )
    WhiteSmoke              = RGB(*HtmlColorTuples.WhiteSmoke           )
    White                   = RGB(*HtmlColorTuples.White                )